#include <16F88.h>
#device ADC=8
#use delay(clock=8000000)
#use fast_io(B)
#fuses INTRC_IO,NOBROWNOUT,PROTECT,NOCPD,NOLVP,WDT,MCLR,NOPUT
//#OPT compress

#define    ONE_WIRE_PIN PIN_A1
#include   <DS1822.C> 

#rom  0x2100={0,0,0,0,0,30}

#define    sutun1      PIN_A6
#define    sutun2      PIN_A7
#define    sutun3      PIN_A0
#define    sutun4      PIN_A2
#define    sutun5      PIN_A3

#define    modtus      !input(PIN_B6)   
#define    maxcalsmode 31
#define    maxdemosayac 300
#define    TONE_PIN    PIN_B0

//#define    solduy    !input(PIN_A2)
//#define    sagduy    !input(PIN_A1)

#define    up    -1
#define    down   1
#define    left  -1
#define    right  1

#define    ekrON  1

int ekran[21]={0xff,0xff,0xff,0xff,0xff,0xff};
int depo [21]={0xff,0xff,0xff,0xff,0xff,0xff};

//                         H   E   L   L   O
int32 const mesaj1=0b1111101010001011101111011011101;
int32 const mesaj2=0b1111101010111011101110101111111;
int32 const mesaj3=0b1111100010011011101110101110111;
int32 const mesaj4=0b1111101010111011101110101011101;
int32 const mesaj5=0b1111101010001000100011011100011;

//int A5 = 0;   // For the button on pin A5 

signed int temperature, eskitemp;

int calsmode, eskicalsmode, demomode, transtimer, transay, ilktemp, sayilansayi, sayigecik;

int pingyonx=right, pingyony= down;
int pingx=2, pingy=3, pingmode;
int pingsayac=1;

int karayonx=right;
int karax=2;
int karasayac=1;
int16 tempsuresi, demosayac;

void ekran_tara();
//************************************************
/*#INT_RB 
void portb_isr(){ 

}*/
//************************************************
#INT_TIMER2 
void timer2_isr(){ 
   //intsayisi++;
   
   if(transay != 5 ){
      if (transtimer-- == 0){
         transay++;
         transtimer=15;
      }
   }

   output_b (ekran[transay]&0xfe);
   output_low(sutun1);
   delay_ms(1);
   output_high(sutun1);

   output_b (ekran[transay+1]&0xfe);
   output_low(sutun2);
   delay_ms(1);
   output_high(sutun2);

   output_b (ekran[transay+2]&0xfe);
   output_low(sutun3);
   delay_ms(1);
   output_high(sutun3);

   output_b (ekran[transay+3]&0xfe);
   output_low(sutun4);
   delay_ms(1);
   output_high(sutun4);

   output_b (ekran[transay+4]&0xfe);
   output_low(sutun5);
   delay_ms(1);
   output_high(sutun5);
}
//************************************************
void beep(int16 period){
disable_interrupts(GLOBAL); 
set_tris_b(0b01000000);
   while((period--) != 0)
   {
      output_high(TONE_PIN);
      delay_ms(2);
      output_low(TONE_PIN);
      delay_ms(2);
   }
set_tris_b(0b01000001);   
//   output_float(TONE_PIN);
enable_interrupts(GLOBAL); 
}
//************************************************
void efektpin(int sayac,int kere){
int depo;

depo = kere;

      output_high(TONE_PIN);
          for(;kere>0;kere--)      delay_us(sayac);
      output_low(TONE_PIN);
      kere = depo;
          for(;kere>0;kere--)      delay_us(sayac);
}
//************************************************
void ciuv(int tekrar, int frqrange, int1 yon, int frek){

int sayac,depo;

 while((tekrar--) != 0)
 {
   if(yon){
    for(sayac=1;sayac<frqrange;sayac++)
      {
      efektpin(sayac,frek);
      }
   }
   else {
   for(sayac=frqrange;sayac>0;sayac--)
      {
      efektpin(sayac,frek);
      }
   }
 }
 depo = input(tone_pin);
}
//-----------------------------------------
void bekle(int16 period){
   while(period > 0)
   {
      period--;
      delay_us(1);
   }
}

//-----------------------------------------
void pixbas(int x, int y,int cls){
if(cls==1){
   ekran[5] = 0b11111111;
   ekran[6] = 0b11111111;
   ekran[7] = 0b11111111;
   ekran[8] = 0b11111111;
   ekran[9] = 0b11111111;
}
bit_clear(ekran[y+4], 7-x);
}
//-----------------------------------------
void pingpong2(){
      pingsayac--;
      if(pingsayac==0){
         pingsayac = 4;
         //if(pingyonx>1 || pingyonx <-1) pingyonx = 1;
         //if(pingyony>1 || pingyony <-1) pingyony = 1;         
         pingx = pingx + pingyonx;
         if (pingx == 6 || pingx==2 ) { pingyonx = -pingyonx; }
         pingy = pingy + pingyony;
         if (pingy == 5 || pingy==1 ) { pingyony = -pingyony; }
         //if(pingx>6) pingx=2;
         //if(pingy>5) pingy=3;
         pixbas(pingx,pingy,1);
      }
}

//----------------------------------------
void karasimsek(int karamod){
karasayac--;
      if(karasayac==0){
         karasayac = 4;
         karax = karax + karayonx;
         
         if(karamod==1){
         if (karax == 6 || karax==2 ) { karayonx = -karayonx; }
               pixbas(karax,1,1);
               pixbas(karax,5,0);
               pixbas(karax,2,0);
               pixbas(karax,4,0);
               pixbas(karax,3,0);
         }
         else{
         if (karax == 5 || karax==1 ) { karayonx = -karayonx; }
               pixbas(2,karax,1);
               pixbas(6,karax,0);
               pixbas(3,karax,0);
               pixbas(5,karax,0);
               pixbas(4,karax,0);         
         }
      }
}
//----------------------------------------
void karedondur(int karemod){
pingsayac--;
      if(pingsayac==0){
         pingsayac = 2;
         
         switch (pingmode) {
            case 0:
               pingx=1;
               pingy=1;
               pingmode=1;
               pixbas(pingx,pingy,1);
               if(karemod==2)pixbas(8-pingx,6-pingy,0);
            break;
            case 1:
               if(pingx < 6) pingx++;
               else  { pingmode=2; pingy++; }
               pixbas(pingx,pingy,1);
               if(karemod==2)pixbas(8-pingx,6-pingy,0);
            break;
            case 2:
               if(pingy < 5) pingy++;
               else  { pingmode=3; pingx--; }
               pixbas(pingx,pingy,1);
               if(karemod==2)pixbas(8-pingx,6-pingy,0);
            break;
            case 3:
               if(pingx != 2) pingx--;
               else  { pingmode=4; pingy--;}
               pixbas(pingx,pingy,1);
               if(karemod==2)pixbas(8-pingx,6-pingy,0);
            break;            
            case 4:
               if(pingy != 1) pingy--;
               else  { pingmode=1; pingx++; }
               pixbas(pingx,pingy,1);
               if(karemod==2)pixbas(8-pingx,6-pingy,0);
            break;            
         }
      }
}
//----------------------------------------
void harfbak(int harf){
int depot;

depot = harf;
//harf = harf & 0b00000011;

switch (harf) {
   case 0:
      depo[5] = 0b00001100;
      depo[6] = 0b00001100;
      depo[7] = 0b00001100;
      depo[8] = 0b00001100;
      depo[9] = 0b00001100;
   break;
   case 1:
      depo[5] = 0b00001110;
      depo[6] = 0b00001100;
      depo[7] = 0b00001110;
      depo[8] = 0b00001110;
      depo[9] = 0b00001110;   
   break;
   case 2:
      depo[5] = 0b00001100;
      depo[6] = 0b00001110;
      depo[7] = 0b00001100;
      depo[8] = 0b00001101;
      depo[9] = 0b00001100;   
   break;
   case 3:
      depo[5] = 0b00001100;
      depo[6] = 0b00001110;
      depo[7] = 0b00001100;
      depo[8] = 0b00001110;
      depo[9] = 0b00001100;   
   break;
  case 4:
      depo[5] = 0b00001101;
      depo[6] = 0b00001100;
      depo[7] = 0b00001100;
      depo[8] = 0b00001110;
      depo[9] = 0b00001110;   
   break;
   case 5:
      depo[5] = 0b00001100;
      depo[6] = 0b00001101;
      depo[7] = 0b00001100;
      depo[8] = 0b00001110;
      depo[9] = 0b00001100;   
   break;
   case 6:
      depo[5] = 0b00001100;
      depo[6] = 0b00001101;
      depo[7] = 0b00001100;
      depo[8] = 0b00001100;
      depo[9] = 0b00001100;   
   break;
   case 7:
      depo[5] = 0b00001100;
      depo[6] = 0b00001110;
      depo[7] = 0b00001110;
      depo[8] = 0b00001101;
      depo[9] = 0b00001101;   
   break;
   case 8:
      depo[5] = 0b00001100;
      depo[6] = 0b00001100;
      depo[7] = 0b00001111;
      depo[8] = 0b00001100;
      depo[9] = 0b00001100;   
   break;
   case 9:
      depo[5] = 0b00001100;
      depo[6] = 0b00001100;
      depo[7] = 0b00001100;
      depo[8] = 0b00001110;
      depo[9] = 0b00001101;   
   break;   
default:
      depo[5] = 0b01111111;
      depo[6] = 0b01111111;
      depo[7] = 0b01111111;
      depo[8] = 0b01111111;
      depo[9] = 0b01111111;   
   break; }

}
/////////////////////////////////////////////////////
void ekransil(){
   ekran[5] = 0xFF;
   ekran[6] = 0xFF;
   ekran[7] = 0xFF;
   ekran[8] = 0xFF;
   ekran[9] = 0xFF;
}
/////////////////////////////////////////////////////
void kaydir(){

int32 m1 = mesaj1, m2=mesaj2, m3=mesaj3, m4=mesaj4, m5=mesaj5;
int kere;

kere = 24;



//ekransil();

do{
   restart_wdt();
   if (modtus){
      beep(20);
      while(modtus);
      return;
   }
   depo[5] =(m1>>kere) ;
   depo[6] =(m2>>kere) ;
   depo[7] =(m3>>kere) ;
   depo[8] =(m4>>kere) ;
   depo[9] =(m5>>kere) ;
   
   ekran[5] = depo[5] ;
   ekran[6] = depo[6] ;
   ekran[7] = depo[7] ;
   ekran[8] = depo[8] ;
   ekran[9] = depo[9] ;

bekle((75-kere*3)/2);
}while(kere-- !=0);

   bekle(300);

   depo[0]=0b1111111;
   depo[1]=0b1111111;
   depo[2]=0b1111111;
   depo[3]=0b1111111;
   depo[4]=0b1111111;

//ekransil();
}
/////////////////////////////////////////////////////
void temp( ){
int onlar=0, birler=0;

   while (!onewire_init_with_error_check()){
   
   }
     if( onewire_init_with_error_check() ){
         onewire_ds1822_set_temperature_resolution(9); 
         temperature = onewire_ds1822_read_temp_c_lite();   // Returns only + temps
     }
     else{
         output_low(ONE_WIRE_PIN);
     }

eskitemp = temperature;
  while(temperature >= 10) {
      temperature -= 10;
      onlar++;
  }    
birler =     temperature ;
  

   harfbak(onlar);
   depo [10] = (depo [5]<<4) & 0b01110000;
   depo [11] = (depo [6]<<4) & 0b01110000;
   depo [12] = (depo [7]<<4) & 0b01110000;
   depo [13] = (depo [8]<<4) & 0b01110000;
   depo [14] = (depo [9]<<4) & 0b01110000;

   harfbak(birler);
   depo [10] |= depo [5]<<1 & 0b00001111;
   depo [11] |= depo [6]<<1 & 0b00001111;
   depo [12] |= depo [7]<<1 & 0b00001111;
   depo [13] |= depo [8]<<1 & 0b00001111;
   depo [14] |= depo [9]<<1 & 0b00001111;
   
}
/////////////////////////////////////////////////////
void ekranyukle(int neyi){
   if(eskicalsmode==neyi){
      depo[0]=ekran[5];
      depo[1]=ekran[6];   
      depo[2]=ekran[7];
      depo[3]=ekran[8];
      depo[4]=ekran[9];
   }
}
/////////////////////////////////////////////////////
void depoyakoy(int depomod){
switch(depomod){
   case 2:
   depo[0]=0b11111111;
   depo[1]=0b11111111;
   depo[2]=0b11110111;  // 1
   depo[3]=0b11111111;
   depo[4]=0b11111111;   
   break;
   case 3:
   depo[0]=0b11111111;
   depo[1]=0b11110111;
   depo[2]=0b11100011;  // 5
   depo[3]=0b11110111;
   depo[4]=0b11111111;  
   break;
   case 4:
   depo[0]=0b1011101;
   depo[1]=0b1111111;
   depo[2]=0b1111111;  // 7
   depo[3]=0b1011101;
   depo[4]=0b1100011;
   break;   
   case 5:
   depo[0]=0b11111111;
   depo[1]=0b11100011;
   depo[2]=0b11101011;  // 8
   depo[3]=0b11100011;
   depo[4]=0b11111111;    
   break;
   case 6:
   depo[0]=0b11011101;
   depo[1]=0b11101011;
   depo[2]=0b11110111;  // 9
   depo[3]=0b11101011;
   depo[4]=0b11011101;    
   break;
   case 7:
   depo[0]=0b1101011;
   depo[1]=0b1010101;
   depo[2]=0b1011101;  // 10     heart
   depo[3]=0b1101011;
   depo[4]=0b1110111;   
   break; 
   case 8:
   depo[0]=0b1010101;
   depo[1]=0b1101010;
   depo[2]=0b1010101;  // 12    chequered flag A
   depo[3]=0b1101010;
   depo[4]=0b1010101;
   break;   
   case 9:
   depo[0]=0b11110111;
   depo[1]=0b11100011;
   depo[2]=0b11000001;  // 13
   depo[3]=0b11100011;
   depo[4]=0b11110111; 
   break;
   case 10:
   depo[0]=0b11000001;
   depo[1]=0b11011101;
   depo[2]=0b11011101;  // 16
   depo[3]=0b11011101;
   depo[4]=0b11000001;    
   break;   
   case 11:
   depo[0]=0b11100011;
   depo[1]=0b11001001;
   depo[2]=0b11010101;  // 17
   depo[3]=0b11001001;
   depo[4]=0b11100011;    
   break;      
   case 12:
   depo[0]=0b1001001;
   depo[1]=0b1010101;
   depo[2]=0b1100011;  // 17    yonca
   depo[3]=0b1010101;
   depo[4]=0b1001001;
   break;     
   case 13:
   depo[0]=0b11100011;
   depo[1]=0b11000001;
   depo[2]=0b11000001;  // 21
   depo[3]=0b11000001;
   depo[4]=0b11100011; 
   break;   
   case 14:
   depo[0]=0b11000001;
   depo[1]=0b11000001;
   depo[2]=0b11000001;  // 25 
   depo[3]=0b11000001;
   depo[4]=0b11000001;
   break;   
   case 15:    // TEMP
   depo[0]=0b1111111;
   depo[1]=0b1111111;
   depo[2]=0b1111111;
   depo[3]=0b1111111;
   depo[4]=0b1111111;
   ekranyukle(15);
   break;      
   case 16:
   pingx = 2 ;
   pingy = 3 ;
   pingyonx = 1;
   pingyony = 1;
   ekranyukle(16);
   break;  
   case 17:
   karax = 3 ;
   ekranyukle(17);   
   break;  
   case 18:
   karax = 4 ;
   ekranyukle(18);
   break; 
   case 19:
   pingmode=0;
   ekranyukle(19);
   break; 
   case 20:
   pingmode=0;
   ekranyukle(20);
   break; 
   case 21:   
   depo[0]=0b1111111;
   depo[1]=0b1111111;
   depo[2]=0b1111111;
   depo[3]=0b1111111;
   depo[4]=0b1111111;
   ekranyukle(depomod);   
   break;     
   case 22:   
   temp();
   depo[0] = depo[10];
   depo[1] = depo[11];
   depo[2] = depo[12];
   depo[3] = depo[13];
   depo[4] = depo[14];
   //ekranyukle(15);
   tempsuresi=1;
   break;     
   case 23:   
   depo[0]=0b1111111;
   depo[1]=0b1111111;
   depo[2]=0b1111111;
   depo[3]=0b1111111;
   depo[4]=0b1111111;
   ekranyukle(depomod);   
   break;      
   case 24:   
   depo[0]=0b1001001;
   depo[1]=0b1001001;
   depo[2]=0b1001001;
   depo[3]=0b1001001;
   depo[4]=0b1001001;
   ekranyukle(depomod);   
   break;   
   case 25:   
   depo[0]=0b1111111;
   depo[1]=0b1111111;
   depo[2]=0b1110111;
   depo[3]=0b1111111;
   depo[4]=0b1111111;
   ekranyukle(depomod);   
   break;      
   case 26:   
   depo[0]=0b1111111;
   depo[1]=0b1111111;
   depo[2]=0b1110111;
   depo[3]=0b1111111;
   depo[4]=0b1111111;
   ekranyukle(depomod);   
   break;     
   case 27:   
   depo[0]=0b1011111; 
   depo[1]=0b1011111;
   depo[2]=0b1011111;
   depo[3]=0b1101111;
   depo[4]=0b1110111;
   ekranyukle(depomod);   
   break; 
   case 28:   
   depo[0]=0b1111111;
   depo[1]=0b1111111;
   depo[2]=0b1000001;
   depo[3]=0b1111111;
   depo[4]=0b1111111;
   ekranyukle(depomod);   
   break;    
   case 29:   
   depo[0]=0b1111111;
   depo[1]=0b1111111;
   depo[2]=0b1111111;
   depo[3]=0b1111111;
   depo[4]=0b1111111;
   ekranyukle(depomod);   
   break;     
   case 30:   
   depo[0]=0b1111111;
   depo[1]=0b1111111;
   depo[2]=0b1111111;
   depo[3]=0b1111111;
   depo[4]=0b1111111;
   ekranyukle(depomod);   
   break;        
   case 31:
   depo[0]=0b1111111;
   depo[1]=0b1111111;
   depo[2]=0b1111111;
   depo[3]=0b1111111;
   depo[4]=0b1111111;
   ekranyukle(depomod);   
   break;     
   }
}
/////////////////////////////////////////////////////
void modeg(int mod){

   if ( mod == 1) {
      //eskicalsmode = calsmode;
      calsmode++;
      if(calsmode > maxcalsmode ) calsmode = 2;
   }
   
      depoyakoy(eskicalsmode);
      ekran[0]=depo[0];
      ekran[1]=depo[1];
      ekran[2]=depo[2];
      ekran[3]=depo[3];
      ekran[4]=depo[4];  
      
      depoyakoy(calsmode);
      ekran[5]=depo[0];
      ekran[6]=depo[1];
      ekran[7]=depo[2];
      ekran[8]=depo[3];
      ekran[9]=depo[4];   
}
/////////////////////////////////////////////////////
void tvackapa(int tvmode){
   switch(tvmode){
      case 0:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;
      case 1:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;
      case 2:
      ekran[5]=0b1111111;
      ekran[6]=0b1101011;
      ekran[7]=0b1110111;
      ekran[8]=0b1101011;
      ekran[9]=0b1111111;
      break;
      case 3:
      ekran[5]=0b1011101;
      ekran[6]=0b1100011;
      ekran[7]=0b1101011;
      ekran[8]=0b1100011;
      ekran[9]=0b1011101;
      break;
      case 4:
      ekran[5]=0b1101011;
      ekran[6]=0b1000001;
      ekran[7]=0b1110111;
      ekran[8]=0b1000001;
      ekran[9]=0b1101011;
      break;
      case 5:
      ekran[5]=0b1100011;
      ekran[6]=0b1000001;
      ekran[7]=0b1010101;
      ekran[8]=0b1000001;
      ekran[9]=0b1010101;
      break;
      case 6:
      ekran[5]=0b1100011;
      ekran[6]=0b1000001;
      ekran[7]=0b1010001;
      ekran[8]=0b1000001;
      ekran[9]=0b1010101;
      break;
      case 7:
      ekran[5]=0b1100011;
      ekran[6]=0b1000001;
      ekran[7]=0b1010101;
      ekran[8]=0b1000001;
      ekran[9]=0b1010101;
      break;
      case 8:
      ekran[5]=0b1111111;
      ekran[6]=0b1100011;
      ekran[7]=0b1000001;
      ekran[8]=0b1100011;
      ekran[9]=0b1111111;
      break;
      case 9:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1000001;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;
      case 10:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1100011;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;
      case 11:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break; 
      case 12:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;    
      case 13:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;  
      case 14:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;      
      case 15:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;
      default:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;         
   }
}
/////////////////////////////////////////////////////
void warpgate(int warpmode){
   switch(warpmode){
      case 0:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111; 
      break;
      case 1:
      ekran[5]=0b1111111;
      ekran[6]=0b1100011;
      ekran[7]=0b1101011;
      ekran[8]=0b1100011;
      ekran[9]=0b1111111;
      break;
      case 2:
      ekran[5]=0b1000001;
      ekran[6]=0b1011101;
      ekran[7]=0b1011101;
      ekran[8]=0b1011101;
      ekran[9]=0b1000001;
      break;
      case 3:
      ekran[5]=0b1111111;
      ekran[6]=0b1100011;
      ekran[7]=0b1101011;
      ekran[8]=0b1100011;
      ekran[9]=0b1111111;
      break;      
      default:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;      
   }
}
/////////////////////////////////////////////////////
void explode(int expmode){
   switch(expmode){
      case 0:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111; 
      break;
      case 1:
      ekran[5]=0b1111111;
      ekran[6]=0b1101011;
      ekran[7]=0b1110111;
      ekran[8]=0b1101011;
      ekran[9]=0b1111111;
      break;
      case 2:
      ekran[5]=0b1011101;
      ekran[6]=0b1101011;
      ekran[7]=0b1110111;
      ekran[8]=0b1101011;
      ekran[9]=0b1011101;
      break;
      case 3:
      ekran[5]=0b1011101;
      ekran[6]=0b1101011;
      ekran[7]=0b1111111;
      ekran[8]=0b1101011;
      ekran[9]=0b1011101;
      break;      
      case 4:
      ekran[5]=0b1011101;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1011101;
      break;            
      case 5:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;
      case 6:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;      
      default:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;      
   }
}
/////////////////////////////////////////////////////
void wiper(int wipmode){
   switch(wipmode){
      case 0:
      ekran[5]=0b1011111;
      ekran[6]=0b1011111;
      ekran[7]=0b1101111;
      ekran[8]=0b1101111;
      ekran[9]=0b1110111; 
      break;
      case 1:
      break;       
      case 2:
      break;             
      case 3:
      ekran[5]=0b1011111;
      ekran[6]=0b1101111;
      ekran[7]=0b1101111;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;
      case 4:
      ekran[5]=0b1101111;
      ekran[6]=0b1101111;
      ekran[7]=0b1110111;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;
      case 5:
      ekran[5]=0b1110111;
      ekran[6]=0b1110111;
      ekran[7]=0b1110111;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;      
      case 6:
      ekran[5]=0b1111011;
      ekran[6]=0b1111011;
      ekran[7]=0b1110111;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;            
      case 7:
      ekran[5]=0b1111101;
      ekran[6]=0b1111011;
      ekran[7]=0b1111011;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;
      case 8:
      ekran[5]=0b1111101;
      ekran[6]=0b1111101;
      ekran[7]=0b1111011;
      ekran[8]=0b1111011;
      ekran[9]=0b1110111;
      break;      
      case 9:
      break;  
      case 10:
      break;       
      case 11:
      ekran[5]=0b1111101;
      ekran[6]=0b1111011;
      ekran[7]=0b1111011;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;
      case 12:
      ekran[5]=0b1111011;
      ekran[6]=0b1111011;
      ekran[7]=0b1110111;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;
      case 13:
      ekran[5]=0b1110111;
      ekran[6]=0b1110111;
      ekran[7]=0b1110111;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;      
      case 14:
      ekran[5]=0b1101111;
      ekran[6]=0b1101111;
      ekran[7]=0b1110111;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;
      case 15:
      ekran[5]=0b1011111;
      ekran[6]=0b1101111;
      ekran[7]=0b1101111;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;
   }
}
/////////////////////////////////////////////////////
void cizgidon(int cizmode){
   switch(cizmode){
      case 0:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1000001;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111; 
      break;
      case 1:
      break;
      case 2:
      break;
      case 3:
      ekran[5]=0b1111111;
      ekran[6]=0b1011111;
      ekran[7]=0b1100011;
      ekran[8]=0b1111101;
      ekran[9]=0b1111111;
      break;
      case 4:
      ekran[5]=0b1111111;
      ekran[6]=0b1001111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111001;
      ekran[9]=0b1111111;
      break;
      case 5:
      ekran[5]=0b1011111;
      ekran[6]=0b1101111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111011;
      ekran[9]=0b1111101;
      break;      
      case 6:
      break;      
      case 7:
      ekran[5]=0b1101111;
      ekran[6]=0b1110111;
      ekran[7]=0b1110111;
      ekran[8]=0b1110111;
      ekran[9]=0b1111011;
      break;            
      case 8:
      ekran[5]=0b1110111;
      ekran[6]=0b1110111;
      ekran[7]=0b1110111;
      ekran[8]=0b1110111;
      ekran[9]=0b1110111;
      break;
      case 9:
      break;
      case 10:
      break;
      case 11:
      ekran[5]=0b1111011;
      ekran[6]=0b1110111;
      ekran[7]=0b1110111;
      ekran[8]=0b1110111;
      ekran[9]=0b1101111;
      break;      
      case 12:
      ekran[5]=0b1111101;
      ekran[6]=0b1111011;
      ekran[7]=0b1110111;
      ekran[8]=0b1101111;
      ekran[9]=0b1011111;
      break;
      case 13:
      break;
      case 14:
      ekran[5]=0b1111111;
      ekran[6]=0b1111001;
      ekran[7]=0b1110111;
      ekran[8]=0b1001111;
      ekran[9]=0b1111111;
      break;
      case 15:
      ekran[5]=0b1111111;
      ekran[6]=0b1111101;
      ekran[7]=0b1100011;
      ekran[8]=0b1011111;
      ekran[9]=0b1111111;
      break;       
   }
}
/////////////////////////////////////////////////////
void vumetre1(int vummode){
   switch(vummode){
      case 0:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1010101; 
      break;    
      case 1:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1011101;
      ekran[9]=0b1010101;
      break;
      case 2:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1011101;
      ekran[8]=0b1010101;
      ekran[9]=0b1000001;
      break;
      case 3:
      ekran[5]=0b1111111;
      ekran[6]=0b1011101;
      ekran[7]=0b1010101;
      ekran[8]=0b1000001;
      ekran[9]=0b1000001;
      break;      
      case 4:
      ekran[5]=0b1011101;
      ekran[6]=0b1010101;
      ekran[7]=0b1000001;
      ekran[8]=0b1000001;
      ekran[9]=0b1000001;
      break;            
      case 5:
      ekran[5]=0b1010101;
      ekran[6]=0b1000001;
      ekran[7]=0b1000001;
      ekran[8]=0b1000001;
      ekran[9]=0b1000001;
      break;
      case 6:
      ekran[5]=0b1000001;
      ekran[6]=0b1000001;
      ekran[7]=0b1000001;
      ekran[8]=0b1000001;
      ekran[9]=0b1000001;
      break;
      case 7:
      ekran[5]=0b1010101;
      ekran[6]=0b1000001;
      ekran[7]=0b1000001;
      ekran[8]=0b1000001;
      ekran[9]=0b1000001;
      break;
      case 8:
      ekran[5]=0b1011101;
      ekran[6]=0b1010101;
      ekran[7]=0b1000001;
      ekran[8]=0b1000001;
      ekran[9]=0b1000001;
      break;
/*      case 9:
      ekran[5]=0b1111111;
      ekran[6]=0b1011101;
      ekran[7]=0b1010101;
      ekran[8]=0b1000001;
      ekran[9]=0b1000001;
      break;
      case 10:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1011101;
      ekran[8]=0b1010101;
      ekran[9]=0b1000001;
      break;
      case 11:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1011101;
      ekran[9]=0b1010101;
      break;
      case 12:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1010101;
      break;
     */
   }
}
/////////////////////////////////////////////////////
void dadon(int damode){
   switch(damode){
      case 0:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1110111; 
      break;     
      case 1:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1110111;
      ekran[9]=0b1111111; 
      break;           
      case 2:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111; 
      break;
      case 3:
      ekran[5]=0b1111111;
      ekran[6]=0b1110111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;
      case 4:
      ekran[5]=0b1101011;
      ekran[6]=0b1110111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;
      case 5:
      ekran[5]=0b1101011;
      ekran[6]=0b1010101;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;      
      case 6:
      ekran[5]=0b1101011;
      ekran[6]=0b1010101;
      ekran[7]=0b1011101;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;         
      case 7:
      ekran[5]=0b1101011;
      ekran[6]=0b1010101;
      ekran[7]=0b1011101;
      ekran[8]=0b1101011;
      ekran[9]=0b1111111;
      break;
      case 8:
      ekran[5]=0b1101011;
      ekran[6]=0b1010101;
      ekran[7]=0b1011101;
      ekran[8]=0b1101011;
      ekran[9]=0b1110111;
      break;
      case 9:
      ekran[5]=0b1101011;
      ekran[6]=0b1010101;
      ekran[7]=0b1011101;
      ekran[8]=0b1101011;
      ekran[9]=0b1110111;
      break;
      case 10:
      break;
      case 11:
      ekran[5]=0b1101011;
      ekran[6]=0b1010101;
      ekran[7]=0b1011101;
      ekran[8]=0b1101011;
      ekran[9]=0b1110111;
      break;
      case 12:
      ekran[5]=0b1101011;
      ekran[6]=0b1011101;
      ekran[7]=0b1011101;
      ekran[8]=0b1101011;
      ekran[9]=0b1110111;
      break;
      case 13:
      ekran[5]=0b1111111;
      ekran[6]=0b1011101;
      ekran[7]=0b1011101;
      ekran[8]=0b1101011;
      ekran[9]=0b1110111;
      break;
      case 14:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1011101;
      ekran[8]=0b1101011;
      ekran[9]=0b1110111;
      break;
      case 15:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1101011;
      ekran[9]=0b1110111;
      break;
   }
}
/////////////////////////////////////////////////////
void kumsaat(int kumode){
   switch(kumode){
      default:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1100011;
      ekran[9]=0b1000001; 
      break; 
      case 1:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110001;
      ekran[8]=0b1110011;
      ekran[9]=0b1110111;
      break;      
      case 2:
      ekran[5]=0b1111101;
      ekran[6]=0b1111001;
      ekran[7]=0b1110001;
      ekran[8]=0b1111001;
      ekran[9]=0b1111101;
      break;      
      case 3:
      ekran[5]=0b1110111;
      ekran[6]=0b1110011;
      ekran[7]=0b1110001;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;         
      case 4:
      ekran[5]=0b1000001;
      ekran[6]=0b1100011;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;
      break;
      case 5:
      ekran[5]=0b1001001;
      ekran[6]=0b1100011;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1110111;
      break;
      case 6:
      ekran[5]=0b1011001;
      ekran[6]=0b1100011;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1100111;
      break;      
      case 7:
      ekran[5]=0b1011101;
      ekran[6]=0b1100011;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1100011;
      break;            
      case 8:
      ekran[5]=0b1111101;
      ekran[6]=0b1100011;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1000011;
      break;
      case 9:
      ekran[5]=0b1111111;
      ekran[6]=0b1100011;
      ekran[7]=0b1110111;
      ekran[8]=0b1111111;
      ekran[9]=0b1000001;
      break;
      case 10:
      ekran[5]=0b1111111;
      ekran[6]=0b1101011;
      ekran[7]=0b1110111;
      ekran[8]=0b1101111;
      ekran[9]=0b1000001;
      break;
      case 11:
      ekran[5]=0b1111111;
      ekran[6]=0b1110111;
      ekran[7]=0b1110111;
      ekran[8]=0b1101011;
      ekran[9]=0b1000001;
      break;
      case 12:
      ekran[5]=0b1111111;
      ekran[6]=0b1110111;
      ekran[7]=0b1111111;
      ekran[8]=0b1100011;
      ekran[9]=0b1000001;
      break;
      case 13:
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1110111;
      ekran[8]=0b1100011;
      ekran[9]=0b1000001;
      break;      
   }
}
/////////////////////////////////////////////////////
void welcome(){
   ekran[5]=0b1010111;
   ekran[6]=0b1010101;
   ekran[7]=0b1000111;
   ekran[8]=0b1010101;
   ekran[9]=0b1010101;
   bekle(150);

   ekran[5]=0b1011101;
   ekran[6]=0b1111111;
   ekran[7]=0b1111111;
   ekran[8]=0b1011101;
   ekran[9]=0b1100011;
   bekle(150);
   }
   
/////////////////////////////////////////////////////
void strobo(int1 dolubos){
   if(dolubos==1){
      ekran[5]=0b1000001;
      ekran[6]=0b1000001;
      ekran[7]=0b1000001;
      ekran[8]=0b1000001;
      ekran[9]=0b1000001;   
   }
   else{
      ekran[5]=0b1111111;
      ekran[6]=0b1111111;
      ekran[7]=0b1111111;
      ekran[8]=0b1111111;
      ekran[9]=0b1111111;      
   }
}
/////////////////////////////////////////////////////
void sayisay(){
int sayidepo;
int onlar=0, birler=0;


sayidepo = sayilansayi;
while(sayidepo >= 10) {
   sayidepo -= 10;
   onlar++;
}    
birler = sayidepo ;

   harfbak(onlar);
   depo [10] = (depo [5]<<4) & 0b01110000;
   depo [11] = (depo [6]<<4) & 0b01110000;
   depo [12] = (depo [7]<<4) & 0b01110000;
   depo [13] = (depo [8]<<4) & 0b01110000;
   depo [14] = (depo [9]<<4) & 0b01110000;

   harfbak(birler);
   depo [10] |= depo [5]<<1 & 0b00001111;
   depo [11] |= depo [6]<<1 & 0b00001111;
   depo [12] |= depo [7]<<1 & 0b00001111;
   depo [13] |= depo [8]<<1 & 0b00001111;
   depo [14] |= depo [9]<<1 & 0b00001111;
   
   ekran[5] = depo[10];
   ekran[6] = depo[11];
   ekran[7] = depo[12];
   ekran[8] = depo[13];
   ekran[9] = depo[14];   
}
//----------------------------------------
void tengu(int tengmod){


switch (tengmod) {
   case 0:
      ekran[5] = 0b0011100;
      ekran[6] = 0b0111110;
      ekran[7] = 0b0111110;
      ekran[8] = 0b0111110;
      ekran[9] = 0b0110110;
   break;
   case 1:
      ekran[5] = 0b0011100;
      ekran[6] = 0b0111110;
      ekran[7] = 0b0111110;
      ekran[8] = 0b0111110;
      ekran[9] = 0b0100010;
   break;
   case 2:
      ekran[5] = 0b0011100;
      ekran[6] = 0b0111110;
      ekran[7] = 0b0111110;
      ekran[8] = 0b0011100;
      ekran[9] = 0b0100010;
   break;
   case 3:
      ekran[5] = 0b0011100;
      ekran[6] = 0b0111110;
      ekran[7] = 0b0100010;
      ekran[8] = 0b0011100;
      ekran[9] = 0b0100010;  
   break;
  case 4:
      ekran[5] = 0b0011100;
      ekran[6] = 0b0111110;
      ekran[7] = 0b0000000;
      ekran[8] = 0b0011100;
      ekran[9] = 0b0100010;
   break;
   case 5:
      ekran[5] = 0b0011100;
      ekran[6] = 0b0100010;
      ekran[7] = 0b0011100;
      ekran[8] = 0b0011100;
      ekran[9] = 0b0100010;
   break;
   case 6:
      ekran[5] = 0b0011100;
      ekran[6] = 0b0000000;
      ekran[7] = 0b0011100;
      ekran[8] = 0b0011100;
      ekran[9] = 0b0100010;
   break;
   case 7:
      ekran[5] = 0b0000000;
      ekran[6] = 0b0011100;
      ekran[7] = 0b0011100;
      ekran[8] = 0b0011100;
      ekran[9] = 0b0100010;
   break;
   case 8:
      ekran[5] = 0b0000000;
      ekran[6] = 0b0010100;
      ekran[7] = 0b0011100;
      ekran[8] = 0b0011100;
      ekran[9] = 0b0000000;
   break;
   /*default:
      depo[5] = 0b0111110;
      depo[6] = 0b0111110;
      depo[7] = 0b0111110;
      depo[8] = 0b0111110;
      depo[9] = 0b0111110;
   break; */
   }
/*   
   ekran[5]=depo[5];
   ekran[6]=depo[6];
   ekran[7]=depo[7];
   ekran[8]=depo[8];
   ekran[9]=depo[9];
*/
}
/////////////////////////////////////////////////////
void main ( )
{

int sayac;
int tuskod, tuskodsay, tuskodran;
int okunanadc, anaval,anahed;

setup_comparator (NC_NC_NC_NC);
SETUP_WDT (WDT_2304MS);
setup_oscillator(OSC_8MHZ);
port_b_pullups(0b01000000);

SETUP_ADC_PORTS(sAN4);
setup_adc(ADC_CLOCK_INTERNAL);            
set_adc_channel(4); 

setup_timer_2(T2_DIV_BY_1,6,8); 
set_tris_b(0b01000001);
calsmode = read_eeprom(5);
if ( calsmode > maxcalsmode ) calsmode = 2;
transay=5;
ekransil();
enable_interrupts(INT_TIMER2); 
enable_interrupts(GLOBAL); 
if(RESTART_CAUSE()==NORMAL_POWER_UP) kaydir();
beep(10);
modeg(0);
tuskod=0;
tuskodsay = 0;
tuskodran = 1;
tempsuresi=2;
sayilansayi=0;
sayigecik=3;
demomode=0;
anahed=0;

while(TRUE){
restart_wdt();
set_tris_b(0b01000001);
  
   if(calsmode==15) strobo( bit_test(sayac,2) );    
   if(calsmode==16) pingpong2();
   if(calsmode==17) karasimsek(1);
   if(calsmode==18) karasimsek(2);
   if(calsmode==19) karedondur(1); 
   if(calsmode==20) karedondur(2); 
   if(calsmode==21) kumsaat((sayac>>4)&0b00001111);    
   if(calsmode==22) {
      if (tempsuresi-- == 0) {
         temp(); 
         ekran[5] = depo[10];
         ekran[6] = depo[11];
         ekran[7] = depo[12];
         ekran[8] = depo[13];
         ekran[9] = depo[14];
         ilktemp=1;
         tempsuresi=1500; 
      }
   }   
   if(calsmode==23) tvackapa((sayac>>3)&0b00001111); 
   if(calsmode==24) { 
      sayisay();
      if ( sayigecik-- ==0) { 
         sayilansayi++;
         if(sayilansayi==60 || sayilansayi==15 || sayilansayi==30 || sayilansayi==45 ) beep(10);
         sayigecik=23;
      }
      if( sayilansayi == 60 ) sayilansayi=0;
   }
   if(calsmode==25) warpgate ((sayac>>2)&0b00000111); 
   if(calsmode==26) explode  ((sayac>>2)&0b00000111); 
   if(calsmode==27) wiper    ((sayac>>2)&0b00001111); 
   if(calsmode==28) cizgidon ((sayac   )&0b00001111);    
   if(calsmode==29) dadon    ((sayac>>2)&0b00001111);  
   if(calsmode==30 || calsmode==31) //vumetre1 ((sayac   )&0b00001111);  
   //if(calsmode==31) 
   {
   
      if(bit_test(sayac,0)) okunanadc = read_Adc();
      if(okunanadc< 1) anaval=0;     // 5 ten bala 5 er art eklinde idi
      else if(okunanadc<2) anaval=1;
           else if(okunanadc<3) anaval=2;
                else if(okunanadc<4) anaval=3;
                     else if(okunanadc<5) anaval=4;
                          else if(okunanadc<6) anaval=5;
                               else if(okunanadc<7) anaval=6; 
                                    else if(okunanadc<8) anaval=7;
                                         else anaval=8;
   if(anaval>anahed) anahed++;
   if(anaval<anahed) anahed--;
   if(calsmode==31) tengu(anahed);
   if(calsmode==30) vumetre1(anahed);
   bekle(5);
   }
   if(demomode==1) {
      if (demosayac-- == 0) {
         demosayac=maxdemosayac;
         eskicalsmode=calsmode;
         modeg(1);
         transay = 0;
         transtimer = 10;
      }
   }
   
   if( tuskodsay != 0) {
      tuskodsay--;
      tuskodran = 0;
   }
   else{ 
      if( tuskodran == 0 ){
         beep(10);
         eskicalsmode = calsmode;
         if(tuskod!=1){
            if ( calsmode == tuskod ) {
               demomode=1;
               demosayac=maxdemosayac;
               //ciuv(4,100,1,1);
            }
            calsmode = tuskod;
            modeg(0);
         }
         else {
            modeg(1);
         }
         if(demomode!=1) write_eeprom ( 5, calsmode );
         transay = 0;
         transtimer = 10;
         tuskodran = 1;
         tuskod=0;
      }
   }
   
   if (modtus) 
   {  
      //while(modtus) disable_interrupts(INT_TIMER2);  
      //enable_interrupts(INT_TIMER2); 
      if(demomode==1){
         demomode = 0;
         write_eeprom ( 5, calsmode );
      }
      else{
         tuskodsay=80;
         tuskod++;
      }
      beep(10);
      //bekle(10);
      while(modtus);
   }
sayac++;
}
} 
